<?php

namespace Drp\AdfsSocialiteProvider;

use Illuminate\Contracts\Auth\Authenticatable;
use Illuminate\Support\Facades\Crypt;

class TemporaryUser implements Authenticatable
{
    /** @var string */
    public $email;

    /** @var string */
    public $name;

    /** @var string */
    public $username;

    public function __construct(string $email, string $username, string $name)
    {
        $this->email = $email;
        $this->name = $name;
        $this->username = $username;
    }

    public static function fromId(string $id)
    {
        return new self(...explode('_', $id, 3));
    }

    public function getAuthIdentifierName()
    {
        return $this->name;
    }

    public function getAuthIdentifier()
    {
        return Crypt::encrypt($this->email . '_' . $this->username . '_' . $this->name);
    }

    public function getAuthPassword()
    {
        return '';
    }

    public function getRememberToken()
    {
        return '';
    }

    public function setRememberToken($value)
    {
    }

    public function getRememberTokenName()
    {
        return '';
    }
}
